/* mapping table of MathML elements */
#include "MathML.h"
static ElemMapping    MathMLElemMappingTable[] =
{
   /* This table MUST be in alphabetical order */
   {TEXT("XMLPI"), SPACE, MathML_EL_XMLPI, L_Other, FALSE},
   {TEXT("XMLPI_line"), SPACE, MathML_EL_XMLPI_line, L_Other, FALSE},
   {TEXT("XMLcomment"), SPACE, MathML_EL_XMLcomment, L_Other, FALSE},
   {TEXT("XMLcomment_line"), SPACE, MathML_EL_XMLcomment_line, L_Other, FALSE},
   {TEXT("c"), SPACE, MathML_EL_TEXT_UNIT, L_Other, TRUE},
   {TEXT("maligngroup"), 'E', MathML_EL_MALIGNGROUP, L_Other, FALSE},
   {TEXT("malignmark"), 'E', MathML_EL_MALIGNMARK, L_Other, FALSE},
   {TEXT("math"), SPACE, MathML_EL_MathML, L_Other, FALSE},
   {TEXT("menclose"), SPACE, MathML_EL_MENCLOSE, L_Other, FALSE},
   {TEXT("merror"), SPACE, MathML_EL_MERROR, L_Other, FALSE},
   {TEXT("mf"), SPACE, MathML_EL_MF, L_Other, FALSE},  /* for compatibility with an old version of MathML: WD-math-970704 */
   {TEXT("mfenced"), SPACE, MathML_EL_MFENCED, L_Other, FALSE},
   {TEXT("mfrac"), SPACE, MathML_EL_MFRAC, L_Other, FALSE},
   {TEXT("mglyph"), 'E', MathML_EL_MGLYPH, L_Other, FALSE},
   {TEXT("mi"), SPACE, MathML_EL_MI, L_Other, FALSE},
   {TEXT("mlabeledtr"), SPACE, MathML_EL_MLABELEDTR, L_Other, FALSE},
   {TEXT("mmultiscripts"), SPACE, MathML_EL_MMULTISCRIPTS, L_Other, FALSE},
   {TEXT("mn"), SPACE, MathML_EL_MN, L_Other, FALSE},
   {TEXT("mo"), SPACE, MathML_EL_MO, L_Other, FALSE},
   {TEXT("mover"), SPACE, MathML_EL_MOVER, L_Other, FALSE},
   {TEXT("mpadded"), SPACE, MathML_EL_MPADDED, L_Other, FALSE},
   {TEXT("mphantom"), SPACE, MathML_EL_MPHANTOM, L_Other, FALSE},
   {TEXT("mprescripts"), SPACE, MathML_EL_PrescriptPairs, L_Other, FALSE},
   {TEXT("mroot"), SPACE, MathML_EL_MROOT, L_Other, FALSE},
   {TEXT("mrow"), SPACE, MathML_EL_MROW, L_Other, FALSE},
   {TEXT("ms"), SPACE, MathML_EL_MS, L_Other, FALSE},
   {TEXT("mspace"), 'E', MathML_EL_MSPACE, L_Other, FALSE},
   {TEXT("msqrt"), SPACE, MathML_EL_MSQRT, L_Other, FALSE},
   {TEXT("mstyle"), SPACE, MathML_EL_MSTYLE, L_Other, FALSE},
   {TEXT("msub"), SPACE, MathML_EL_MSUB, L_Other, FALSE},
   {TEXT("msubsup"), SPACE, MathML_EL_MSUBSUP, L_Other, FALSE},
   {TEXT("msup"), SPACE, MathML_EL_MSUP, L_Other, FALSE},
   {TEXT("mtable"), SPACE, MathML_EL_MTABLE, L_Other, FALSE},
   {TEXT("mtd"), SPACE, MathML_EL_MTD, L_Other, FALSE},
   {TEXT("mtext"), SPACE, MathML_EL_MTEXT, L_Other, FALSE},
   {TEXT("mtr"), SPACE, MathML_EL_MTR, L_Other, FALSE},
   {TEXT("munder"), SPACE, MathML_EL_MUNDER, L_Other, FALSE},
   {TEXT("munderover"), SPACE, MathML_EL_MUNDEROVER, L_Other, FALSE},
   {TEXT("none"), SPACE, MathML_EL_Construct, L_Other, FALSE},
   {TEXT(""), SPACE, 0, L_Other, FALSE}	 /* Last entry. Mandatory */
};

static AttributeMapping MathMLAttributeMappingTable[] =
{
   /* The first entry MUST be unknown_attr */
   /* The rest of this table MUST be in alphabetical order */
   {TEXT("unknown_attr"), TEXT(""), 'A', MathML_ATTR_Invalid_attribute, L_Other},

   {TEXT("accent"), TEXT(""), 'A', MathML_ATTR_accent, L_Other},
   {TEXT("accentunder"), TEXT(""), 'A', MathML_ATTR_accentunder, L_Other},
   {TEXT("actiontype"), TEXT(""), 'A', MathML_ATTR_actiontype, L_Other},
   {TEXT("align"), TEXT(""), 'A', MathML_ATTR_align, L_Other},
   {TEXT("alignmentscope"), TEXT(""), 'A', MathML_ATTR_alignmentscope, L_Other},
   {TEXT("alt"), TEXT(""), 'A', MathML_ATTR_alt, L_Other},
   {TEXT("altimg"), TEXT(""), 'A', MathML_ATTR_altimg, L_Other},
   {TEXT("alttext"), TEXT(""), 'A', MathML_ATTR_alttext, L_Other},
   {TEXT("background"), TEXT(""), 'A', MathML_ATTR_background_, L_Other},
   {TEXT("bevelled"), TEXT(""), 'A', MathML_ATTR_bevelled, L_Other},
   {TEXT("class"), TEXT(""), 'A', MathML_ATTR_class, L_Other},
   {TEXT("close"), TEXT(""), 'A', MathML_ATTR_close, L_Other},
   {TEXT("columnalign"), TEXT("mtd"), 'A', MathML_ATTR_columnalign_mtd, L_Other},
   {TEXT("columnalign"), TEXT(""), 'A', MathML_ATTR_columnalign, L_Other},
   {TEXT("columnlines"), TEXT(""), 'A', MathML_ATTR_columnlines, L_Other},
   {TEXT("columnspacing"), TEXT(""), 'A', MathML_ATTR_columnspacing, L_Other},
   {TEXT("columnspan"), TEXT(""), 'A', MathML_ATTR_columnspan, L_Other},
   {TEXT("columnwidth"), TEXT(""), 'A', MathML_ATTR_columnwidth, L_Other},
   {TEXT("color"), TEXT(""), 'A', MathML_ATTR_color, L_Other},
   {TEXT("denomalign"), TEXT(""), 'A', MathML_ATTR_denomalign, L_Other},
   {TEXT("depth"), TEXT(""), 'A', MathML_ATTR_depth_, L_Other},
   {TEXT("display"), TEXT(""), 'A', MathML_ATTR_display, L_Other},
   {TEXT("displaystyle"), TEXT(""), 'A', MathML_ATTR_displaystyle, L_Other},
   {TEXT("edge"), TEXT(""), 'A', MathML_ATTR_edge, L_Other},
   {TEXT("equalcolumns"), TEXT(""), 'A', MathML_ATTR_equalcolumns, L_Other},
   {TEXT("equalrows"), TEXT(""), 'A', MathML_ATTR_equalrows, L_Other},
   {TEXT("fence"), TEXT(""), 'A', MathML_ATTR_fence, L_Other},
   {TEXT("fontfamily"), TEXT(""), 'A', MathML_ATTR_fontfamily, L_Other},
   {TEXT("fontstyle"), TEXT(""), 'A', MathML_ATTR_fontstyle, L_Other},
   {TEXT("fontsize"), TEXT(""), 'A', MathML_ATTR_fontsize, L_Other},
   {TEXT("fontweight"), TEXT(""), 'A', MathML_ATTR_fontweight, L_Other},
   {TEXT("form"), TEXT(""), 'A', MathML_ATTR_form, L_Other},
   {TEXT("frame"), TEXT(""), 'A', MathML_ATTR_frame, L_Other},
   {TEXT("framespacing"), TEXT(""), 'A', MathML_ATTR_framespacing, L_Other},
   {TEXT("groupalign"), TEXT("maligngroup"), 'A', MathML_ATTR_groupalign_malgr, L_Other},
   {TEXT("groupalign"), TEXT(""), 'A', MathML_ATTR_groupalign, L_Other},
   {TEXT("height"), TEXT(""), 'A', MathML_ATTR_height_, L_Other},
   {TEXT("id"), TEXT(""), 'A', MathML_ATTR_id, L_Other},
   {TEXT("index"), TEXT(""), 'A', MathML_ATTR_index, L_Other},
   {TEXT("largeop"), TEXT(""), 'A', MathML_ATTR_largeop, L_Other},
   {TEXT("linebreak"), TEXT(""), 'A', MathML_ATTR_linebreak_, L_Other},
   {TEXT("linethickness"), TEXT(""), 'A', MathML_ATTR_linethickness, L_Other},
   {TEXT("lquote"), TEXT(""), 'A', MathML_ATTR_lquote, L_Other},
   {TEXT("lspace"), TEXT(""), 'A', MathML_ATTR_lspace, L_Other},
   {TEXT("mathbackground"), TEXT(""), 'A', MathML_ATTR_mathbackground, L_Other},
   {TEXT("mathcolor"), TEXT(""), 'A', MathML_ATTR_mathcolor, L_Other},
   {TEXT("mathsize"), TEXT(""), 'A', MathML_ATTR_mathsize, L_Other},
   {TEXT("mathvariant"), TEXT(""), 'A', MathML_ATTR_mathvariant, L_Other},
   {TEXT("maxsize"), TEXT(""), 'A', MathML_ATTR_maxsize, L_Other},
   {TEXT("minlabelspacing"), TEXT(""), 'A', MathML_ATTR_minlabelspacing, L_Other},
   {TEXT("minsize"), TEXT(""), 'A', MathML_ATTR_minsize, L_Other},
   {TEXT("mode"), TEXT(""), 'A', MathML_ATTR_display, L_Other},
   {TEXT("movablelimits"), TEXT(""), 'A', MathML_ATTR_movablelimits, L_Other},
   {TEXT("notation"), TEXT(""), 'A', MathML_ATTR_notation, L_Other},
   {TEXT("numalign"), TEXT(""), 'A', MathML_ATTR_numalign, L_Other},
   {TEXT("open"), TEXT(""), 'A', MathML_ATTR_open, L_Other},
   {TEXT("other"), TEXT(""), 'A', MathML_ATTR_other, L_Other},
   {TEXT("overflow"), TEXT(""), 'A', MathML_ATTR_overflow, L_Other},
   {TEXT("rowalign"), TEXT("mtr"), 'A', MathML_ATTR_rowalign_mtr, L_Other},
   {TEXT("rowalign"), TEXT("mlabeledtr"), 'A', MathML_ATTR_rowalign_mtr, L_Other},
   {TEXT("rowalign"), TEXT("mtd"), 'A', MathML_ATTR_rowalign_mtr, L_Other},
   {TEXT("rowalign"), TEXT(""), 'A', MathML_ATTR_rowalign, L_Other},
   {TEXT("rowlines"), TEXT(""), 'A', MathML_ATTR_rowlines, L_Other},
   {TEXT("rowspacing"), TEXT(""), 'A', MathML_ATTR_rowspacing, L_Other},
   {TEXT("rowspan"), TEXT(""), 'A', MathML_ATTR_rowspan_, L_Other},
   {TEXT("rquote"), TEXT(""), 'A', MathML_ATTR_rquote, L_Other},
   {TEXT("rspace"), TEXT(""), 'A', MathML_ATTR_rspace, L_Other},
   {TEXT("scriptlevel"), TEXT(""), 'A', MathML_ATTR_scriptlevel, L_Other},
   {TEXT("scriptminsize"), TEXT(""), 'A', MathML_ATTR_scriptminsize, L_Other},
   {TEXT("scriptsizemultiplier"), TEXT(""), 'A', MathML_ATTR_scriptsizemultiplier, L_Other},
   {TEXT("selection"), TEXT(""), 'A', MathML_ATTR_selection, L_Other},
   {TEXT("separator"), TEXT(""), 'A', MathML_ATTR_separator, L_Other},
   {TEXT("separators"), TEXT(""), 'A', MathML_ATTR_separators, L_Other},
   {TEXT("side"), TEXT(""), 'A', MathML_ATTR_side, L_Other},
   {TEXT("stretchy"), TEXT(""), 'A', MathML_ATTR_stretchy, L_Other},
   {TEXT("style"), TEXT(""), 'A', MathML_ATTR_style_, L_Other},
   {TEXT("subscriptshift"), TEXT(""), 'A', MathML_ATTR_subscriptshift, L_Other},
   {TEXT("superscriptshift"), TEXT(""), 'A', MathML_ATTR_superscriptshift, L_Other},
   {TEXT("symmetric"), TEXT(""), 'A', MathML_ATTR_symmetric, L_Other},
   {TEXT("width"), TEXT(""), 'A', MathML_ATTR_width_, L_Other},
   {TEXT("xml:space"), TEXT(""), 'A', MathML_ATTR_xml_space, L_Other},
   {TEXT("xref"), TEXT(""), 'A', MathML_ATTR_xref, L_Other},
   {TEXT("zzghost"), TEXT(""), 'A', MathML_ATTR_Ghost_restruct, L_Other},

   {TEXT(""), TEXT(""), EOS, 0, L_Other}		/* Last entry. Mandatory */
};


XmlEntity  MathEntityTable[] =
{
   /* This table MUST be in alphabetical order */
   /* This table contains characters from the Symbol font plus some
      specific MathML entities */
   {TEXT("Aacute"), 192, 'L'},
   {TEXT("Acirc"), 194, 'L'},
   /* 913 */{TEXT("Agr"), 65, 'G'},
   /* 10835 */{TEXT("And"), 217, 'G'},
   {TEXT("ApplyFunction"), 129, 'L'},   /* rendered as a thin space */
   {TEXT("Backslash"), 92, 'L'},
   /* 914 */{TEXT("Bgr"), 66, 'G'},
   /* 8914 */{TEXT("Cap"), 199, 'G'},
   /* 183 */{TEXT("CenterDot"), 215, 'G'},
   /* 8853 */{TEXT("CirclePlus"), 197, 'G'},
   /* 8855 */{TEXT("CircleTimes"), 196, 'G'},
   /* 8759 */{TEXT("Colon"), 58, 'G'},
   /* 8773 */{TEXT("Congruent"), 64, 'G'},
   /* 8915 */{TEXT("Cup"), 200, 'G'},
   /* 8711 */{TEXT("Del"), 209, 'G'},
   /* 916 */{TEXT("Delta"), 68, 'G'},
   /* 8900 */{TEXT("Diamond"), 168, 'G'},
   /* 8518 */{TEXT("DifferentialD"), 100, 'L'},
   /* 8659 */{TEXT("DoubleDownArrow"), 223, 'G'},
   /* 8656 */{TEXT("DoubleLeftArrow"), 220, 'G'},
   /* 8660 */{TEXT("DoubleLeftRightArrow"), 219, 'G'},
   /* 8658 */{TEXT("DoubleRightArrow"), 222, 'G'},
   /* 8657 */{TEXT("DoubleUpArrow"), 221, 'G'},
   /* 8595 */{TEXT("DownArrow"), 175, 'G'},
   /* 8868 */{TEXT("DownTee"), 94, 'G'},
   /* 919 */{TEXT("EEgr"), 72, 'G'},
   /* 917 */{TEXT("Egr"), 69, 'G'},
   /* 8712 */{TEXT("Element"), 206, 'G'},
   {TEXT("Equal"), 61, 'L'},
   /* 8770 */{TEXT("EqualTilde"), 64, 'G'},
   /* 8707 */{TEXT("Exists"), 36, 'G'},
   {TEXT("ExponentialE"), 101, 'L'},
   /* 8704 */{TEXT("ForAll"), 34, 'G'},
   /* 915 */{TEXT("Gamma"), 71, 'G'},
   /* 8805 */{TEXT("GreaterEqual"), 179, 'G'},
   {TEXT("Hat"), 94, 'L'},
   /* 921 */{TEXT("Igr"), 73, 'G'},
   {TEXT("ImaginaryI"), 105, 'L'},
   /* 8747 */{TEXT("Integral"), 242, 'G'},
   /* 8898 */{TEXT("Intersection"), 199, 'G'},
   {TEXT("InvisibleComma"), 129, 'L'},   /* thin space */
   {TEXT("InvisibleTimes"), 129, 'L'},   /* thin space */
   /* 922 */{TEXT("Kgr"), 75, 'G'},
   /* 935 */{TEXT("KHgr"), 67, 'G'},
   /* 923 */{TEXT("Lambda"), 76, 'G'},
   /* 9001 */{TEXT("LeftAngleBracket"), 225, 'G'},
   /* 8656 ? */{TEXT("LeftArrow"), 172, 'G'},
   /* 8968 */{TEXT("LeftCeiling"), 233, 'G'},
   /* 8970 */{TEXT("LeftFloor"), 235, 'G'},
   /* 8596 */{TEXT("LeftRightArrow"), 171, 'G'},
   /* 924 */{TEXT("Mgr"), 77, 'G'},
   /* 925 */{TEXT("Ngr"), 78, 'G'},
   {TEXT("NonBreakingSpace"), 160, 'L'},
   /* 10988 */{TEXT("Not"), 216, 'G'},
   /* 8713 */{TEXT("NotElement"), 207, 'G'},
   /* 8800 */{TEXT("NotEqual"), 185, 'G'},
   /* 8836 */{TEXT("NotSubset"), 203, 'G'},
   /* 927 */{TEXT("Ogr"), 79, 'G'},
   /* 937 */{TEXT("Omega"), 87, 'G'},
   /* 1083 */{TEXT("Or"), 218, 'G'},
   /* 175 */{TEXT("OverBar"), 45, 'G'},
   /* 65079 */{TEXT("OverBrace"), 132, 'G'},    /* 132?? */
   /* 8719 */{TEXT("PI"), 213, 'G'},
   /* 8706 */{TEXT("PartialD"), 182, 'G'},
   /* 934 */{TEXT("Phi"), 70, 'G'},
   /* 928 */{TEXT("Pi"), 80, 'G'},
   /* 177? */{TEXT("PlusMinus"), 177, 'G'},
   /* 8243 */{TEXT("Prime"), 178, 'G'},
   /* 8719 */{TEXT("Product"), 213, 'G'},
   /* 8733 */{TEXT("Proportional"), 181, 'G'},
   /* 936 */{TEXT("Psi"), 89, 'G'},
   /* 9002 */{TEXT("RightAngleBracket"), 241, 'G'},
   /* 8969 */{TEXT("RightCeiling"), 249, 'G'},
   /* 8971 */{TEXT("RightFloor"), 251, 'G'},
   /* 929 */{TEXT("Rgr"), 82, 'G'},
   /* 8594 */{TEXT("RightArrow"), 174, 'G'},
   /* 931 */{TEXT("Sigma"), 83, 'G'},
   /* 8260 */{TEXT("Sol"), 164, 'G'},
   {TEXT("Star"), 42, 'L'},
   /* 8912 */{TEXT("Subset"), 204, 'G'},
   /* 8838 */{TEXT("SubsetEqual"), 205, 'G'},
   /* 8715 */{TEXT("SuchThat"), 39, 'G'},
   /* 8721 */{TEXT("Sum"), 229, 'G'},
   /* 8835 */{TEXT("Superset"), 201, 'G'},
   /* 8839 */{TEXT("SupersetEqual"), 202, 'G'},
   /* 932 */{TEXT("Tgr"), 84, 'G'},
   /* 8756 */{TEXT("Therefore"), 92, 'G'},
   /* 920 */{TEXT("Theta"), 81, 'G'},
   {TEXT("ThickSpace"), 130, 'L'},
   {TEXT("ThinSpace"), 129, 'L'},
   {TEXT("Tilde"), 126, 'L'},
   /* 8411 */{TEXT("TripleDot"), 188, 'G'},
   /* 818 */{TEXT("UnderBar"), 45, 'G'},
   /* 65080 */{TEXT("UnderBrace"), 133, 'G'},    /* 133?? */
   /* 8899 */{TEXT("Union"), 200, 'G'},
   /* 8593 */{TEXT("UpArrow"), 173, 'G'},
   /* 933 */{TEXT("Upsi"), 85, 'G'},
   /* 978 */{TEXT("Upsi1"), 161, 'G'},
   /* 8897 */{TEXT("Vee"), 218, 'G'},
   /* 8214 */{TEXT("Verbar"), 189, 'G'},
   {TEXT("VerticalBar"), 124, 'L'},
   /* 926 */{TEXT("Xi"), 88, 'G'},
   /* 918 */{TEXT("Zgr"), 90, 'G'},
   {TEXT("aacute"), 224, 'L'},
   {TEXT("acirc"), 226, 'L'},
   {TEXT("acute"), 180, 'L'},
   {TEXT("af"), 129, 'L'},             /* rendered as thin space */
   /* 8501 */{TEXT("aleph"), 192, 'G'},
   /* 945 */{TEXT("alpha"), 97, 'G'},
   /* 8743 */{TEXT("and"), 217, 'G'},
   /* 8736 */{TEXT("angle"), 208, 'G'},
   /* 8776 */{TEXT("ap"), 187, 'G'},
   /* 946 */{TEXT("beta"), 98, 'G'},
   /* 8869 */{TEXT("bot"), 94, 'G'},
   /* 8869 */{TEXT("bottom"), 94, 'G'},
   /* 8226 */{TEXT("bull"), 183, 'G'},
   /* 8745 */{TEXT("cap"), 199, 'G'},
   /* 967 */{TEXT("chi"), 99, 'G'},
   {TEXT("circ"), 94, 'L'},
   /* 9827 */{TEXT("clubs"), 167, 'G'},
   /* 8773 */{TEXT("cong"), 64, 'G'},
   /* 8471? */{TEXT("copysf"), 211, 'G'},
   /* ???? */{TEXT("copyssf"), 227, 'G'},
   /* 8629? */{TEXT("cr"), 191, 'G'},
   /* 8746 */{TEXT("cup"), 200, 'G'},
   /* 8659 */{TEXT("dArr"), 223, 'G'},
   /* 8595 */{TEXT("darr"), 175, 'G'},
   {TEXT("dd"), 100, 'L'},
   /* 176?? */{TEXT("deg"), 176, 'G'},
   /* 948 */{TEXT("delta"), 100, 'G'},
   /* 9830 */{TEXT("diams"), 168, 'G'},
   /* ???? */{TEXT("divide"), 184, 'G'},
   /* 9663 */{TEXT("dtri"), 209, 'G'},
   {TEXT("ee"), 101, 'L'},
   /* 8709 */{TEXT("empty"), 198, 'G'},
   /* 8709 */{TEXT("emptyset"), 198, 'G'},
   /* 8195? */{TEXT("emsp"), 32, 'G'},
   /* 949 */{TEXT("epsiv"), 101, 'G'},
   /* 8801 */{TEXT("equiv"), 186, 'G'},
   /* 951 */{TEXT("eta"), 104, 'G'},
   /* 8707 */{TEXT("exist"), 36, 'G'},
   /* 402 */{TEXT("florin"), 166, 'G'},
   /* 8704 */{TEXT("forall"), 34, 'G'},
   /* 947 */{TEXT("gamma"), 103, 'G'},
   /* 8805 */{TEXT("ge"), 179, 'G'},
   /* 8805 */{TEXT("geq"), 179, 'G'},
   {TEXT("gt"), 62, 'L'},
   /* 9829 */{TEXT("hearts"), 169, 'G'},
   /* 8213 */{TEXT("horbar"), 190, 'G'},
   /* 8660 */{TEXT("iff"), 219, 'G'},
   /* 8465? */{TEXT("ifraktur"), 193, 'G'},
   /* 8712 */{TEXT("in"), 206, 'G'},
   /* 8734 */{TEXT("infin"), 165, 'G'},
   /* 8747 */{TEXT("int"), 242, 'G'},
   /* 953 */{TEXT("iota"), 105, 'G'},
   /* 8712 */{TEXT("isin"), 206, 'G'},
   {TEXT("it"), 129, 'L'},          /* rendered as a thin space */
   /* 954 */{TEXT("kappa"), 107, 'G'},
   /* 8656 */{TEXT("lArr"), 220, 'G'},
   /* 955 */{TEXT("lambda"), 108, 'G'},
   /* 9001 */{TEXT("lang"), 225, 'G'},
   /* 9001 */{TEXT("langle"), 225, 'G'},
   /* 8592 */{TEXT("larr"), 172, 'G'},
   {TEXT("lbrace"), 123, 'L'},
   /* 8968 */{TEXT("lceil"), 233, 'G'},
   {TEXT("lcub"), 123, 'L'},
   /* 8804 */{TEXT("le"), 163, 'G'},
   /* 8804 */{TEXT("leq"), 163, 'G'},
   /* 8970 */{TEXT("lfloor"), 235, 'G'},
   /* 95?? */{TEXT("lowbar"), 95, 'G'},
   /* 9674 */{TEXT("loz"), 224, 'G'},
   /* 8660?? */{TEXT("lrArr"), 219, 'G'},
   /* 8646 */{TEXT("lrarr"), 171, 'G'},
   /* 91?? */{TEXT("lsqb"), 91, 'G'},
   {TEXT("lt"), 60, 'L'},
   /* 215?? */{TEXT("middot"), 215, 'G'},
   /* 8230 */{TEXT("mldr"), 188, 'G'},
   /* 956 */{TEXT("mu"), 109, 'G'},
   /* 8711 */{TEXT("nabla"), 209, 'G'},
   {TEXT("nbsp"), 160, 'L'},
   /* 8800 */{TEXT("ne"), 185, 'G'},
   /* 8800 */{TEXT("neq"), 185, 'G'},
   /* 166?? */{TEXT("not"), 216, 'G'},
   /* 8713 */{TEXT("notin"), 207, 'G'},
   /* 957 */{TEXT("nu"), 110, 'G'},
   /* 959 */{TEXT("ogr"), 111, 'G'},
   /* 969 */{TEXT("omega"), 119, 'G'},
   /* 8853 */{TEXT("oplus"), 197, 'G'},
   /* 8744 */{TEXT("or"), 218, 'G'},
   /* 8855 */{TEXT("otimes"), 196, 'G'},
   /* 8706 */{TEXT("part"), 182, 'G'},
   /* 8869 */{TEXT("perp"), 94, 'G'},
   /* 966 */{TEXT("phi"), 102, 'G'},
   /* 981 */{TEXT("phiv"), 106, 'G'},
   /* 960 */{TEXT("pi"), 112, 'G'},
   /* 118 */{TEXT("piv"), 118, 'G'},
   /* 8242 */{TEXT("prime"), 162, 'G'},
   /* 8733 */{TEXT("prop"), 181, 'G'},
   /* 968 */{TEXT("psi"), 121, 'G'},
   /* 8658 */{TEXT("rArr"), 222, 'G'},
   /* 8730 */{TEXT("radic"), 214, 'G'},
   /* 9002 */{TEXT("rang"), 241, 'G'},
   /* 9002 */{TEXT("rangle"), 241, 'G'},
   /* 8594 */{TEXT("rarr"), 174, 'G'},
   {TEXT("rbrace"), 125, 'L'},
   /* 8969 */{TEXT("rceil"), 249, 'G'},
   {TEXT("rcub"), 125, 'L'},
   /* 8221?? */{TEXT("rdquo"), 178, 'G'},
   /* ??? */{TEXT("regsf"), 210, 'G'},
   /* ??? */{TEXT("regssf"), 226, 'G'},
   /* 8971 */{TEXT("rfloor"), 251, 'G'},
   /* 8476?? */{TEXT("rfraktur"), 194, 'G'},
   /* 961 */{TEXT("rho"), 114, 'G'},
   /* 93?? */{TEXT("rsqb"), 93, 'G'},
   /* 963 */{TEXT("sigma"), 115, 'G'},
   /* 962 */{TEXT("sigmav"), 86, 'G'},
   /* 9824 */{TEXT("spades"), 170, 'G'},
   /* 8834 */{TEXT("sub"), 204, 'G'},
   /* 8838 */{TEXT("sube"), 205, 'G'},
   /* 8842? */{TEXT("subne"), 203, 'G'},
   /* 8834 */{TEXT("subset"), 204, 'G'},
   /* 8721 */{TEXT("sum"), 229, 'G'},
   /* 8835 */{TEXT("sup"), 201, 'G'},
   /* 8839 */{TEXT("supe"), 202, 'G'},
   /* 8835 */{TEXT("supset"), 201, 'G'},
   /* 8839 */{TEXT("supseteq"), 202, 'G'},
   /* 8839 */{TEXT("supseteqq"), 202, 'G'},
   /* 964 */{TEXT("tau"), 116, 'G'},
   /* 8756 */{TEXT("there4"), 92, 'G'},
   /* 8756 */{TEXT("therefore"), 92, 'G'},
   /* 952 */{TEXT("theta"), 113, 'G'},
   /* 977 */{TEXT("thetav"), 74, 'G'},
   {TEXT("thickspace"), 130, 'L'},
   /* ??? */{TEXT("times"), 180, 'G'},
   /* 8482 */{TEXT("trade"), 212, 'G'},
   /* 8482 */{TEXT("tradesf"), 212, 'G'},
   /* ??? */{TEXT("tradessf"), 228, 'G'},
   /* 8657 */{TEXT("uArr"), 221, 'G'},
   /* 8593 */{TEXT("uarr"), 173, 'G'},
   /* 965 */{TEXT("upsi"), 117, 'G'},
   /* 8744 */{TEXT("vee"), 218, 'G'},
   /* 8472 */{TEXT("weierp"), 195, 'G'},
   /* 958 */{TEXT("xi"), 120, 'G'},
   /* 950 */{TEXT("zeta"), 122, 'G'},
   {TEXT("zzzz"), -1, SPACE}		/* this last entry is required */
};

